////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2010-2011 Kentaro Sekimoto  All rights reserved.
////////////////////////////////////////////////////////////////////////////

#include "tinyhal.h"
#include "R61580.h"

BOOL LCD_Initialize()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::Initialize();
	LCD_Clear();
	return true;
}

BOOL LCD_Uninitialize()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return true;
}

void LCD_Clear()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::Clear();
}

void LCD_BitBltEx(int x, int y, int width, int height, UINT32 data[])
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::BitBltEx(x, y, width, height, data);
}

void LCD_BitBlt(int width, int height, int widthInWords, UINT32 data[], BOOL fUseDelta)
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::BitBltEx(0, 0, width, height, data);
}

void LCD_WriteChar(unsigned char c, int row, int col)
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::WriteChar(c, row, col);
}

void LCD_WriteFormattedChar(unsigned char c)
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	R61580_Driver::WriteFormattedChar(c);
}

INT32 LCD_GetWidth()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return g_R61580_Config.Width;
}

INT32 LCD_GetHeight()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return g_R61580_Config.Height;
}

INT32 LCD_GetBitsPerPixel()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return g_R61580_Config.BitsPerPixel;
}

UINT32 LCD_GetPixelClockDivider()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return 0;
}
INT32 LCD_GetOrientation()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return 0;
}

void LCD_PowerSave(BOOL On)
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
}

UINT32 *LCD_GetFrameBuffer()
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return NULL;
}

UINT32 LCD_ConvertColor(UINT32 color)
{
	NATIVE_PROFILE_HAL_DRIVERS_DISPLAY();
	return color;
}
